## tora-3.2.tar.gz

=== CMakeLists.txt ===
#Project Setup
PROJECT(TOra)

##############################################################################################################
########## CMake Setup                                                                              ##########

# Set a default build type if none was specified
IF(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  MESSAGE(STATUS "Setting build type to 'Debug' as none was specified.")
  SET(CMAKE_BUILD_TYPE Debug CACHE STRING "Choose the type of build." FORCE)
  # Set the possible values of build type for cmake-gui
  SET_PROPERTY(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
ENDIF()

# options available for user's input
OPTION(WANT_INTERNAL_QSCINTILLA "Use internal/bundled QScintilla2 source" OFF)
OPTION(WANT_INTERNAL_LOKI "Use internal/bundled Loki source" OFF)
OPTION(ENABLE_ORACLE "Enable/Disable Oracle support at all. Including detection" ON)
OPTION(ENABLE_PGSQL "Enable/Disable PostgreSQL support. Including detection" ON)
OPTION(ENABLE_DB2 "Enable/Disable DB2 support. Including detection" OFF)
OPTION(ENABLE_TERADATA "Enable/Disable Teradata support." OFF)
OPTION(QT5_BUILD "Use Qt5" ON)
OPTION(WANT_RPM "Enable additional RPM related stuff. Additional make package_rpm target" OFF)
OPTION(USE_PCH "Use percompiled headers" OFF)
OPTION(USE_EXPERIMENTAL "Use experimental code" OFF)
OPTION(TEST_APP1 "Simple lexer test" OFF)
OPTION(TEST_APP2 "toConnection/toQuery test" OFF)
OPTION(TEST_APP3 "simple application - execute toWorksheet in a separate application" OFF)
OPTION(TEST_APP4 "simple application - execute toHighlightedText in separate application" OFF)
OPTION(TEST_APP5 "simple application - single tool(tabbed)" OFF)
OPTION(TEST_APP6 "simple application parser(boost/spirit+.dot)" OFF)
OPTION(TEST_APP7 "simple application parser" OFF)
OPTION(TEST_APP8 "simple application - wget" ON)
OPTION(TEST_APP9 "simple application - diff" ON)
OPTION(TEST_APP10 "toCodeView" ON)
OPTION(TEST_APP11 "simple parrser" ON)
OPTION(TEST_APP12 "simple parrser" ON)

#Set our CMake minimum version
#Require 2.4.2 for Qt finding
#Require 2.4.3 for moc change detection and rpath updates for custom cairo install
CMAKE_MINIMUM_REQUIRED(VERSION 3.1 FATAL_ERROR) # qt5 requirement
#CMAKE_POLICY(SET CMP0046 OLD) # The dependency target "revisiontag" of target "tora" does not exist
#CMAKE_POLICY(SET CMP0042 OLD) # MACOSX_RPATH

#Pretty colors
SET(CMAKE_COLOR_MAKEFILE ON)
#Dont force verbose
SET(CMAKE_VERBOSE_MAKEFILE OFF)
#Include current dir
SET(CMAKE_INCLUDE_CURRENT_DIR TRUE)

#Set the custom CMake module directory where our include/lib finders are
SET(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules")

SET(RPM_SPEC "tora.generated.spec")

FIND_PACKAGE(Git)
IF(GIT_FOUND AND EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/.git")
  # a custom target that is always built
  ADD_CUSTOM_TARGET(revisiontag ALL)
  # creates gitrevision.h using cmake script
  ADD_CUSTOM_COMMAND(TARGET revisiontag COMMAND ${CMAKE_COMMAND}
  -DUSE_EXPERIMENTAL=${USE_EXPERIMENTAL}
  -DTARGET_NAME=revisiontag
  -P ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules/getgit.cmake
  WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
  )
  add_definitions("-DHAVE_GITREVISION_H=1")
  include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules/getgit.cmake)
  set (VERSION ${GITVERSION_SHORT})
  set (HAVE_GIT_VERSION 1)
ELSE()
  #Set our version values (if not determined from git tag)
  SET (VERSION_MAJOR "3")
  SET (VERSION_MINOR "2")
  #SET (VERSION_PATCH "0")
  #SET (VERSION_SUFFIX "")
  #SET (VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}${VERSION_SUFFIX})
  SET (VERSION ${VERSION_MAJOR}.${VERSION_MINOR})
  if(EXISTS {CMAKE_CURRENT_SOURCE_DIR}/gitrevision.h)
    add_definitions("-DHAVE_GITREVISION_H=1")
  else()
    file(WRITE  ${CMAKE_BINARY_DIR}/toversion.h "#pragma once\n")
    file(APPEND ${CMAKE_BINARY_DIR}/toversion.h "#define TOVERSION \"${VERSION}\"\n")
    file(APPEND ${CMAKE_BINARY_DIR}/toversion.h "#define TOBUILDTYPE_RELEASE \"Release\"\n")
  endif()
ENDIF()

# Boost headers are required to compile with -DDEBUG (see tologger.h)
# also for trotl sql parser(boost spirit)
# also for liber dot parser(boost spirit)
# SET(Boost_DEBUG TRUE)
IF(WIN32)
  FIND_PACKAGE(Boost 1.48.0 REQUIRED)
ELSEIF(APPLE)
  FIND_PACKAGE(Boost 1.48.0 REQUIRED)
ELSE()
  FIND_PACKAGE(Boost 1.48.0 REQUIRED system)
ENDIF()

IF (Boost_FOUND)
    MESSAGE(STATUS "Found Boost libraries for debug build: ${Boost_INCLUDE_DIRS}; libs: ${Boost_LIBRARY_DIRS}")
ELSE (Boost_FOUND)
    MESSAGE(FATAL_ERROR "Boost libs not found.")
ENDIF (Boost_FOUND)

IF (APPLE)
  SET(EXE_NAME "TOra")
ELSE()
  SET(EXE_NAME "tora")  
ENDIF(APPLE)

# For Windows only. Plugings depend on the main program binary. Therefore we must also create .exp .lib (for each .exe)
# The plugin's .dll must be linked against one of them (usually against tora.lib). 
# Change this setting if you're compiling some test program(otherwise the test will SEGFAULT)
IF(WIN32)
  SET(TORA_LIB ${EXE_NAME}) 
  #SET(TORA_LIB test5)
ENDIF()

# Ok, it has to be called after project is set. The we are sure we have size of void pointer set correctly...
INCLUDE(LibSuffix)

#Set the permissions to be used when installing plugins
SET(PLUGIN_PERMISSIONS WORLD_EXECUTE GROUP_EXECUTE OWNER_EXECUTE WORLD_READ GROUP_READ OWNER_READ OWNER_WRITE)


##############################################################################################################
########## check for the CPU we build for                                                           ##########
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
IF (CMAKE_COMPILER_IS_GNUCC)
  SET(CMAKE_CXX_FLAGS_DEBUG   "-Wall -ggdb3 -O0 -fno-inline -rdynamic")
  SET(CMAKE_C_FLAGS_DEBUG     "-Wall -ggdb3 -O0 -fno-inline -rdynamic")
#   SET(CMAKE_CXX_FLAGS_RELEASE "-Wall -std=c++11 -ggdb3 -O2")
#   SET(CMAKE_C_FLAGS_RELEASE   "-Wall            -ggdb3 -O2")
#   SET(CMAKE_CXX_FLAGS         "-Wall -std=c++11 -ggdb3")
#   SET(CMAKE_C_FLAGS           "-Wall            -ggdb3")
ENDIF (CMAKE_COMPILER_IS_GNUCC)

## matches Linux Clang and also AppleClang
IF (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  SET(CMAKE_CXX_FLAGS_DEBUG   "-Wall -ggdb3 -O0 -fno-inline")
  SET(CMAKE_C_FLAGS_DEBUG     "-Wall -ggdb3 -O0 -fno-inline")
#   SET(CMAKE_CXX_FLAGS_RELEASE "-Wall -std=c++11 -ggdb3 -O2")
#   SET(CMAKE_C_FLAGS_RELEASE   "-Wall            -ggdb3 -O2")
#   SET(CMAKE_CXX_FLAGS         "-Wall -std=c++11 -ggdb3")
#   SET(CMAKE_C_FLAGS           "-Wall            -ggdb3")
ENDIF()

#Convert our simpler command line option to the CMake style
#None, Debug, Release, .. or custom ones
IF (CMAKE_BUILD_TYPE MATCHES [Dd]ebug)
  message(STATUS "Debug build")
  set(CMAKE_BUILD_TYPE Debug)
  add_definitions(-DDEBUG -DQT_DEBUG)
  set(TORA_DEBUG TRUE)
ELSE()
  message(STATUS "non-debug build")
  set(TORA_DEBUG FALSE)
  add_definitions(-DNDEBUG -DQT_NO_DEBUG)
  add_definitions(-DQT_NO_DEBUG_OUTPUT)
ENDIF()


# Lets disable Wall warnings due the MSVC too much talkative
# output. Wall can slow down compiletion up to hours and
# my boxes can boil eggs too.
# MSVC, MSVC_IDE, MSVC60, MSVC70, MSVC71, MSVC80, CMAKE_COMPILER_2005
IF (MSVC)
  SET (CXX_WARNINGS "")
  ADD_DEFINITIONS(-D_CRT_SECURE_NO_DEPRECATE)
ELSE (MSVC)
  SET (CXX_WARNINGS "-Wall")
ENDIF (MSVC)


IF (WANT_INTERNAL_LOKI)
  SET(TORA_LOKI_LIB "tora_loki_lib")
  INCLUDE_DIRECTORIES(BEFORE "${CMAKE_SOURCE_DIR}/extlibs/loki/include")
  MESSAGE(STATUS "Using internal loki: ${CMAKE_SOURCE_DIR}/extlibs/loki/include")
ELSE (WANT_INTERNAL_LOKI)
  FIND_PACKAGE(Loki REQUIRED)
  INCLUDE_DIRECTORIES(BEFORE "${LOKI_INCLUDE_DIRS}")
  MESSAGE(STATUS "Using external loki: headers=${LOKI_INCLUDE_DIRS} libs=${LOKI_LIBRARIES}")
ENDIF (WANT_INTERNAL_LOKI)
INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/extlibs/loki-extra/include)

# Required for win when there is used an external qscintilla lib
IF (WIN32 AND NOT DEFINED WANT_INTERNAL_QSCINTILLA)
  SET(CMAKE_CXX_FLAGS_RELEASE "/DQSCINTILLA_DLL ${CMAKE_CXX_FLAGS_RELEASE}")
  SET(CMAKE_C_FLAGS_RELEASE "/DQSCINTILLA_DLL ${CMAKE_C_FLAGS_RELEASE}")
ENDIF (WIN32 AND NOT DEFINED WANT_INTERNAL_QSCINTILLA)

##############################################################################################################
########## Find Dependencies                                                                        ##########

SET(QT_MT_REQUIRED true)
SET(QT_USE_QTNETWORK TRUE)
SET(QT_USE_QTXML TRUE)
SET(QT_USE_QTWEBKIT TRUE)
#SET(CMAKE_AUTOMOC ON)
IF(QT5_BUILD)

  set (QT_FOUND true)
  set(CMAKE_PREFIX_PATH "$ENV{QTDIR}\\") # multiple paths do not work
  find_package(Qt5Core REQUIRED)
  find_package(Qt5Gui REQUIRED)
  find_package(Qt5Network REQUIRED)
  find_package(Qt5PrintSupport REQUIRED)
  find_package(Qt5Sql REQUIRED)
  find_package(Qt5Widgets REQUIRED)
  find_package(Qt5Xml REQUIRED)
  find_package(Qt5LinguistTools)
  IF(APPLE)
    find_package(Qt5MacExtras REQUIRED)
  ENDIF()
  set(QT_INCLUDES
    ${Qt5Core_INCLUDE_DIRS}
    ${Qt5Gui_INCLUDE_DIRS}
    ${Qt5Network_INCLUDE_DIRS}
    ${Qt5PrintSupport_INCLUDE_DIRS}
    ${Qt5Sql_INCLUDE_DIRS}
    ${Qt5Widgets_INCLUDE_DIRS}
    ${Qt5Xml_INCLUDE_DIRS}
  )
  IF(APPLE)    
    LIST(APPEND QT_INCLUDES ${Qt5MacExtras_INCLUDE_DIRS})
  ENDIF()
  include_directories(${QT_INCLUDES})
  # SET(CMAKE_CXX_FLAGS         "${CMAKE_CXX_FLAGS} ${Qt5Core_EXECUTABLE_COMPILE_FLAGS}")
  # SET(CMAKE_C_FLAGS           "${CMAKE_C_FLAGS}   ${Qt5Core_EXECUTABLE_COMPILE_FLAGS}")
  # STRING(TOUPPER "CMAKE_CXX_FLAGS_${CMAKE_BUILD_TYPE}" _flags_var_name)
  # SET(${_flags_var_name}      "${${_flags_var_name}} ${Qt5Core_EXECUTABLE_COMPILE_FLAGS}")
  # SET("CMAKE_CXX_FLAGS_${CMAKE_BUILD_TYPE}" _flags_var_name)
  # # prevent error "You must build your code with position independent code if Qt was built with..
  if (Qt5_POSITION_INDEPENDENT_CODE)
    SET(CMAKE_POSITION_INDEPENDENT_CODE ON)
  endif()
ELSE()
  SET (QT_MIN_VERSION "4.8.0")
  SET (QT_USE_QTSQL TRUE)
  SET (QT_USE_QTNETWORK TRUE)
  SET (QT_USE_QTXML TRUE)
  FIND_PACKAGE(Qt4 REQUIRED)
  INCLUDE( ${QT_USE_FILE} )
ENDIF()
IF (QT_FOUND)
  MESSAGE("Qt Found OK")
  #Add our Qt definitions
  ADD_DEFINITIONS(
    ${QT_DEFINITIONS}
    -DQT_CORE_LIB
    -DQT_GUI_LIB
    -DQT_THREAD_LIB
  )
ELSE(QT_FOUND)
  MESSAGE(FATAL_ERROR "No Qt found")
ENDIF(QT_FOUND)

IF (WANT_INTERNAL_QSCINTILLA)
  MESSAGE(STATUS "QSci: Building with internal copy of QScintilla.")
  MESSAGE(STATUS "QSci: It's recomended to use external library for it")
  INCLUDE_DIRECTORIES(BEFORE
    ${CMAKE_SOURCE_DIR}/extlibs/qscintilla2/include
    ${CMAKE_SOURCE_DIR}/extlibs/qscintilla2/src
    ${CMAKE_SOURCE_DIR}/extlibs/qscintilla2/Qt4Qt5
    ${CMAKE_SOURCE_DIR}/extlibs/qscintilla2/lexlib
  )
ELSE (WANT_INTERNAL_QSCINTILLA)
  FIND_PACKAGE(QScintilla REQUIRED)
  IF (QSCINTILLA_FOUND)
    MESSAGE("QScintilla2 Found OK")
    ADD_DEFINITIONS("-DQT -DSCI_LEXER")
  ELSE (QSCINTILLA_FOUND)
    MESSAGE(STATUS "QSci: No QScintilla2 libraries found")
    MESSAGE(STATUS "QSci: You can use -DWANT_INTERNAL_QSCINTILLA=1 to build included copy of it.")
    MESSAGE(FATAL_ERROR "No QScintilla2 found")
  ENDIF (QSCINTILLA_FOUND)
ENDIF (WANT_INTERNAL_QSCINTILLA)

IF (NOT ENABLE_ORACLE)
  MESSAGE(STATUS "Oracle support is disabled by user choice")
  ADD_DEFINITIONS("-DTO_NO_ORACLE")
ELSE (NOT ENABLE_ORACLE)
  FIND_PACKAGE(Oracle COMPONENTS CLNTSH XML)
  IF(ORACLE_FOUND)
    MESSAGE("Oracle OCI Library Found OK")
  ELSE(ORACLE_FOUND)
    MESSAGE(STATUS "No Oracle OCI found. TOra will be build without Oracle support")
    ADD_DEFINITIONS("-DTO_NO_ORACLE")
  ENDIF(ORACLE_FOUND)
ENDIF (NOT ENABLE_ORACLE)

IF (NOT ENABLE_PGSQL)
  MESSAGE(STATUS "PostgreSQL advanced support is disabled by user choice")
ELSE (NOT ENABLE_PGSQL)
  FIND_PACKAGE(PostgreSQL)
  IF (POSTGRESQL_FOUND)
    ADD_DEFINITIONS(-DLIBPQ_DECL_CANCEL)
    ADD_DEFINITIONS(-DHAVE_POSTGRESQL_LIBPQ_FE_H)

=== extlibs/CMakeLists.txt ===
# include the stack library in dubug builds only
IF (TORA_DEBUG)
  SET (STACK_LIB "stack_lib")
  INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/extlibs/stack)
  ADD_SUBDIRECTORY(stack)
ENDIF (TORA_DEBUG)

# loki library
IF(WANT_INTERNAL_LOKI)
  SET (TORA_LOKI_LIB tora_loki_lib)
  ADD_SUBDIRECTORY(loki)
ENDIF(WANT_INTERNAL_LOKI)

IF(WANT_INTERNAL_QSCINTILLA)
  SET (TORA_QSCINTILLA_LIB tora_qscintilla2_lib)
  ADD_SUBDIRECTORY(qscintilla2)
ENDIF(WANT_INTERNAL_QSCINTILLA)

ADD_SUBDIRECTORY(libermodel)

# Disabled, partially moved into src/parsing
# ADD_SUBDIRECTORY(parsing) 

# trotl library
IF (ORACLE_FOUND)
  ADD_SUBDIRECTORY(trotl)
ENDIF(ORACLE_FOUND)

=== src/CMakeLists.txt ===
# Precompiled headers
IF(USE_PCH AND WIN32 AND MSVC)
  INCLUDE(PrecompiledHeader)
  SET(PCH_DEFINED TRUE)
  SET(PCH_HEADER "precompiled_msvc.h")
  SET(PCH_SOURCE "precompiled/precompiled_msvc.cpp")
ELSEIF (USE_PCH AND CMAKE_COMPILER_IS_GNUCXX AND ${CMAKE_SYSTEM_NAME} MATCHES "Linux")
  INCLUDE(PrecompiledHeader)
  SET(PCH_DEFINED TRUE)
  SET(PCH_HEADER "precompiled/precompiled_linux.h")
ENDIF()

################################################################################
#                              Subdirectories                                  #
################################################################################

# ADD_SUBDIRECTORY(i18n)

################################################################################
#                                 DEFINEs                                      #
################################################################################
IF(USE_EXPERIMENTAL)
  ADD_DEFINITIONS("-DTORA_EXPERIMENTAL")	
ENDIF(USE_EXPERIMENTAL)

################################################################################
#                                 Headers                                      #
################################################################################
INCLUDE_DIRECTORIES(
  ${CMAKE_SOURCE_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}/precompiled
  ${CMAKE_BINARY_DIR}
  ${CMAKE_SOURCE_DIR}/extlibs/trotl/src
  ${CMAKE_SOURCE_DIR}/extlibs/libermodel
  ${CMAKE_SOURCE_DIR}/extlibs/libantlr3cpp-3.5.3/include
  ${CMAKE_SOURCE_DIR}/extlibs/dtl
  ${QT_INCLUDES}  
  )

IF (Boost_FOUND)
  INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIRS})
ENDIF()

IF (ORACLE_INCLUDES)
  INCLUDE_DIRECTORIES( ${ORACLE_INCLUDES} )
ENDIF (ORACLE_INCLUDES)

IF (POSTGRESQL_INCLUDE_DIR)
  INCLUDE_DIRECTORIES( ${POSTGRESQL_INCLUDE_DIR} )
ENDIF (POSTGRESQL_INCLUDE_DIR)

IF (DB2_INCLUDES)
  INCLUDE_DIRECTORIES( ${DB2_INCLUDES} )
ENDIF (DB2_INCLUDES)

IF (TERADATA_INCLUDES)
  INCLUDE_DIRECTORIES( ${TERADATA_INCLUDES} )
ENDIF (TERADATA_INCLUDES)

IF (NOT WANT_INTERNAL_QSCINTILLA)
  INCLUDE_DIRECTORIES(${QSCINTILLA_INCLUDE_DIR})
ENDIF (NOT WANT_INTERNAL_QSCINTILLA)

IF (USE_EXPERIMENTAL)
  IF (POPPLER_QT4_FOUND)
    INCLUDE_DIRECTORIES(${POPPLER_QT4_INCLUDE_DIR})
  ENDIF (POPPLER_QT4_FOUND)
ENDIF(USE_EXPERIMENTAL)

################################################################################
#                              Resource files                                  #
################################################################################
# only toad bindings are here. All others qm files will blow the binary too much
SET (TORA_I18N_TS
  #i18n/tora_fr.ts
  #i18n/tora_it.ts
  #i18n/tora_se.ts
  #i18n/tora_es.ts
  )
SET (TORA_I18N_TS_TOAD i18n/tora_toad.ts)

SET(TORA_RCC_FILES tora.qrc icons.qrc)

################################################################################
#                              User interface files                            #
################################################################################
SET(TORA_UI_SRC
  connection/toqmysqlsettingui.ui
  connection/toqpsqlsettingui.ui

  main/toconnectionimportui.ui
  main/tomessageui.ui
  main/tonewconnectionui.ui
  main/topreferencesui.ui
  main/tosyntaxsetupui.ui

  result/toresulttabledataui.ui

  shortcuteditor/shortcuteditordialog.ui

  tools/tobrowserfilterui.ui
  tools/todescribeui.ui
  tools/todroptablespaceui.ui
  tools/tolinechartsetupui.ui
  tools/tooutputsettingui.ui
  tools/toparamgetui.ui
  tools/torollbackdialogui.ui
  tools/torollbacksettingui.ui
  tools/toscriptschemawidgetui.ui
  tools/toscriptui.ui
  tools/tosecurityquotaui.ui
  tools/tosecurityroleui.ui
  tools/tosecurityuserui.ui
  tools/tosessiondisconnectdlgui.ui
  tools/tosgatracesettingui.ui
  tools/tostoragedatafileui.ui
  tools/tostoragedefinitionui.ui
  tools/tostoragedialogui.ui
  tools/tostorageprefsui.ui
  tools/tostoragetablespaceui.ui
  tools/totuningoverviewui.ui
  tools/totuningsettingui.ui

  widgets/connectioncolorsdialogui.ui
  widgets/toaboutcopyingui.ui
  widgets/toaboutui.ui
  widgets/todatabasesettingui.ui
  widgets/toglobalsettingui.ui
  widgets/tohelpaddfileui.ui
  widgets/tohelpsetupui.ui
  widgets/tohelpui.ui
  widgets/toresultcontentfilterui.ui
  widgets/toresultlistformatui.ui
  widgets/tosearchreplaceui.ui
  widgets/tosessionsetupui.ui
  widgets/totoolsettingui.ui
  widgets/toworksheetsetupui.ui

  #obsolete tools/tobrowserconstraintui.ui
  #obsolete tools/tobrowserindexui.ui
  #obsolete tools/tobrowsertableui.ui

  #     todebugchangeui.ui
  #     todebugwatch.ui

  #     toeditextensionsetupui.ui

  #     tochartalarmui.ui
  #     tochartsetupui.ui


  # #    toschedulerui.ui

  templates/totemplateaddfileui.ui
  templates/totemplateeditui.ui
  templates/totemplatesetupui.ui
  )

IF (ORACLE_FOUND)
  LIST (APPEND TORA_UI_SRC main/tooraclesettingui.ui)
ENDIF (ORACLE_FOUND)

IF (POPPLER_QT4_FOUND)
  #    LIST(APPEND TORA_UI_SRC pdfview/pdfviewwidget.ui)
ENDIF (POPPLER_QT4_FOUND)

################################################################################
#                           QObject sub-classes(moc)                           #
################################################################################
# MOC classses
SET(TORA_MOC_CLASSES
  # Tora core sorces
  connection/toqmysqlsetting.h
  connection/toqpsqlsetting.h
  core/tobackground.h
  core/tocache.h
  core/tochangeconnection.h
  core/tocodemodel.h
  core/toconfenum.h
  core/toconfiguration.h
  core/toconnection.h
  core/toconnectionmodel.h
  core/toconnectionregistry.h
  core/tocontextmenu.h
  core/todatabaseconfig.h
  core/todocklet.h
  core/toeditablemenu.h
  core/toeditmenu.h
  core/toeditorconfiguration.h
  core/toeventquery.h
  core/toeventqueryworker.h
  core/toextract.h
  core/toglobalconfiguration.h
  core/toglobalevent.h
  core/tohelpcontext.h
  core/tolistviewformatter.h
  core/tomainwindow.h
  core/toquery.h
  core/toqueryimpl.h
  core/toresult.h
  core/tosettingtab.h
  core/tostyle.h
  core/tosyntaxanalyzer.h
  core/totextview.h
  core/totool.h
  core/toupdater.h
  core/utils.h
  docklets/toviewconnections.h
  docklets/toviewdirectory.h
  editor/tobaseeditor.h
  editor/tocomplpopup.h
  editor/todebugeditor.h
  editor/todebugtext.h
  editor/todifftext.h
  editor/tohighlightededitor.h
  editor/tomarkededitor.h
  editor/tomemoeditor.h
  editor/tomodeleditor.h
  editor/toscintilla.h
  editor/tosqltext.h
  editor/tosyntaxanalyzermysql.h
  editor/tosyntaxanalyzernl.h
  editor/tosyntaxanalyzeroracle.h
  editor/tosyntaxanalyzerpostgresql.h
  editor/toworksheettext.h

  main/toconnectionimport.h
  main/tomain.h
  main/tomessage.h
  main/tonewconnection.h
  main/topreferences.h
  main/tosyntaxsetup.h

  parsing/tolexermysql.h
  parsing/tolexeroracle.h
  parsing/tolexeroracleapis.h
  parsing/tolexerpostgresql.h
  parsing/toscilexersql.h
  parsing/tsqllexer.h

  result/toproviderobserver.h
  result/toresultlock.h
  result/toresultplan.h
  result/toresultsql.h
  result/toresulttabledata.h
  result/toresultwaitchains.h
  result/totablemodel.h
  result/totreemodel.h

  shortcuteditor/shortcuteditordialog.h
  shortcuteditor/shortcutmodel.h

  templates/tosqledit.h
  templates/totemplate.h

  tools/toanalyze.h
  tools/toawr.h
  tools/tobackup.h
  tools/tobackuptool.h
  tools/tobarchart.h
  tools/tobrowser.h
  tools/tobrowseraccesswidget.h
  tools/tobrowserbasewidget.h # this one is used by widgets/todescribe.h
  tools/tobrowsercodewidget.h
  tools/tobrowserdblinkswidget.h
  tools/tobrowserdirectorieswidget.h
  tools/tobrowserindexwidget.h
  tools/tobrowserschemawidget.h
  tools/tobrowsersequencewidget.h
  tools/tobrowsersynonymwidget.h
  tools/tobrowsertablewidget.h
  tools/tobrowsertriggerwidget.h
  tools/tobrowserviewwidget.h
  tools/tocurrent.h
  tools/todescribe.h
  tools/tofilesize.h
  tools/toinvalid.h
  tools/tolinechart.h
  tools/tooutput.h
  tools/toparamget.h
  tools/topiechart.h
  tools/toplsqleditor.h
  tools/toplsqltext.h
  tools/toprofiler.h
  tools/toresultbar.h
  tools/toresultcode.h
  tools/toresultcols.h
  tools/toresultdatasingle.h
  tools/toresultdepend.h
  tools/toresultdrawing.h
  tools/toresultextent.h
  tools/toresultgrants.h
  tools/toresultline.h
  tools/toresultlong.h
  tools/toresultparam.h
  tools/toresultpie.h
  tools/toresultplan.h
  tools/toresultstats.h
  tools/toresultstorage.h
  tools/toresulttableview.h
  tools/toresulttableviewedit.h
  tools/toresultview.h
  tools/torollback.h
  tools/toscriptschemawidget.h
  tools/toscripttreeitem.h
  tools/toscripttreemodel.h
  tools/tosecurity.h
  tools/tosecuritytreeitem.h
  tools/tosecuritytreemodel.h
  tools/tosession.h
  tools/tosgastatement.h
  tools/tosgatrace.h
  tools/tostorage.h
  tools/totemporary.h
  tools/totuning.h
  tools/totuningcharts.h
  tools/totuningfileio.h
  tools/totuningoverview.h
  tools/tounittest.h
  tools/towaitevents.h
  tools/toworksheet.h
  tools/toworksheeteditor.h
  tools/toworksheetstatistic.h

  ts_log/toostream.h

  views/tocomboview.h
  views/toplaintextview.h
  views/tosqltextview.h
  views/totableview.h
  views/totreeview.h

  widgets/ExtendedTabWidget.h
  widgets/toabout.h
  widgets/toaboutcopying.h
  widgets/tobackgroundlabel.h
  widgets/toconnectionwidget.h
  widgets/todatabasesetting.h
  widgets/todockbar.h
  widgets/toglobalsetting.h
  widgets/tohelp.h
  widgets/tohelpsetup.h
  widgets/topushbutton.h
  widgets/torefreshcombo.h
  widgets/toresultcolscomment.h
  widgets/toresultcombo.h
  widgets/toresultitem.h
  widgets/toresultlistformat.h
  widgets/toresultmodel.h
  widgets/toresultmodeledit.h
  widgets/toresultschema.h
  widgets/tosearchreplace.h
  widgets/tosplash.h
  widgets/totabledetailview.h
  widgets/totableselect.h
  widgets/totabwidget.h
  widgets/totoolwidget.h
  widgets/totreewidget.h
  widgets/toworkingwidget.h
  widgets/toworkspace.h

  docklets/toquerymodel.h
  tools/toer.h

  #obsolete core/todatatype.h
  #obsolete core/torunnable.h
  #obsolete core/totaskrunner.h
  #obsolete core/tothread.h
  #obsolete core/tovisualize.h
  #core/toconfiguration.h
  #core/toconfigurationpriv.h  
  #obsolete tools/tobrowserconstraint.h
  #obsolete tools/tobrowserindex.h
  #obsolete tools/tobrowsertable.h

  #     toproject.h
  
  #TODO tools/toalert.h
  #     todebug.h
  #     todebugtext.h
  #     toeditextensions.h
  # #   toreport.h
  #     toresultlabel.h
  # #   toresultresources.h
  # #   toscheduler.h
  # # tostoragedefinition.h
  )

IF (ORACLE_FOUND)
  LIST(APPEND TORA_MOC_CLASSES main/tooraclesetting.h connection/tooracleconfiguration.h)
ENDIF (ORACLE_FOUND)

IF (POPPLER_QT4_FOUND)
  #    LIST(APPEND TORA_MOC_CLASSES pdfview/documentwidget.h pdfview/pdfviewwidget.h)
ENDIF (POPPLER_QT4_FOUND)

IF (USE_EXPERIMENTAL)
  LIST(APPEND TORA_MOC_CLASSES tools/toscript.h)
  LIST(APPEND TORA_MOC_CLASSES docklets/tocodeoutline.h)

  LIST(APPEND TORA_MOC_CLASSES tools/tosandboxtool.h)

  LIST(APPEND TORA_MOC_CLASSES docklets/tologging.h)
  LIST(APPEND TORA_MOC_CLASSES docklets/tobindvars.h)
ENDIF (USE_EXPERIMENTAL)

################################################################################
#                              Source files .cpp .rc                           #
################################################################################
# sources
SET(TORA_SOURCES
  connection/tooracleextract.cpp
  connection/tooraclesql.cpp
  connection/toqmysqlconnection.cpp
  connection/toqmysqlprovider.cpp
  connection/toqmysqlquery.cpp
  connection/toqmysqlsetting.cpp
  connection/toqmysqltraits.cpp
  connection/toqodbcprovider.cpp
  connection/toqpsqlconnection.cpp
  connection/toqpsqlprovider.cpp
  connection/toqpsqlquery.cpp
  connection/toqpsqlsetting.cpp
  connection/toqpsqltraits.cpp
  connection/toqsqlconnection.cpp
  connection/toqsqlfind.cpp
  connection/toqsqlprovider.cpp
  connection/toqsqlquery.cpp
  connection/toteradatafind.cpp

  core/persistenttrie.cpp
  core/tobackground.cpp
  core/tocache.cpp
  core/tochangeconnection.cpp
  core/tocodemodel.cpp

=== extlibs/libermodel/CMakeLists.txt ===

set(ERMODEL_SRCS
  canvasedge.cpp
  canvaselement.cpp
  canvasnode.cpp
  canvassubgraph.cpp
  dot2qtconsts.cpp
  FontsCache.cpp
  graphedge.cpp
  graphelement.cpp
  graphexporter.cpp
  graphnode.cpp
  graphsubgraph.cpp
  dotgrammar.cpp
  dotgraphview.cpp
  pannerview.cpp
  loadagraphthread.cpp
  dotgraph.cpp
  dotgrammar.cpp
  DotGraphParsingHelper.cpp
  ##simpleprintingcommand.cpp
  layoutagraphthread.cpp
)

SET(ERMODEL_MOC_CLASSES
  canvasedge.h
  canvaselement.h
  canvasnode.h
  graphelement.h
  dotgraphview.h
  pannerview.h
  dotgraph.h
)

if(QT5_BUILD)
QT5_WRAP_CPP(ERMODEL_MOC_SOURCES ${ERMODEL_MOC_CLASSES})
else()
QT4_WRAP_CPP(ERMODEL_MOC_SOURCES ${ERMODEL_MOC_CLASSES})
endif()

INCLUDE_DIRECTORIES(${graphviz_INCLUDE_DIRECTORIES})

IF(Boost_FOUND)
  INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIRS})
ENDIF()

ADD_LIBRARY(ermodel STATIC ${ERMODEL_SRCS} ${ERMODEL_MOC_SOURCES})
TARGET_LINK_LIBRARIES(ermodel ${graphviz_LIBRARIES} ${QT_LIBRARIES})

=== extlibs/loki/CMakeLists.txt ===
SET(TORA_LOKI_LIB_SOURCES

include/loki/AbstractFactory.h
include/loki/AssocVector.h
include/loki/CachedFactory.h
include/loki/ConstPolicy.h
include/loki/DataGenerators.h
include/loki/EmptyType.h
include/loki/Factory.h
include/loki/Function.h
include/loki/Functor.h
include/loki/HierarchyGenerators.h
include/loki/Key.h
include/loki/LockingPtr.h
include/loki/LokiExport.h
include/loki/LokiTypeInfo.h
include/loki/MultiMethods.h
include/loki/NullType.h
include/loki/OrderedStatic.h
include/loki/Pimpl.h
include/loki/RefToValue.h
include/loki/Register.h
include/loki/SPCachedFactory.h
include/loki/SafeFormat.h
include/loki/ScopeGuard.h
include/loki/Sequence.h
include/loki/Singleton.h
include/loki/SmallObj.h
include/loki/SmartPtr.h
include/loki/StrongPtr.h
include/loki/Threads.h
include/loki/Tuple.h
include/loki/TypeManip.h
include/loki/TypeTraits.h
include/loki/Typelist.h
include/loki/TypelistMacros.h
include/loki/Visitor.h

include/loki/flex/allocatorstringstorage.h
include/loki/flex/cowstringopt.h
include/loki/flex/flex_string.h
include/loki/flex/flex_string_details.h
include/loki/flex/flex_string_shell.h
include/loki/flex/simplestringstorage.h
include/loki/flex/smallstringopt.h
include/loki/flex/vectorstringstorage.h

include/loki/static_check.h

include/loki/yasli/platform.h
include/loki/yasli/random.h
include/loki/yasli/yasli_fill_iterator.h
include/loki/yasli/yasli_memory.h
include/loki/yasli/yasli_protocols.h
include/loki/yasli/yasli_traits.h
include/loki/yasli/yasli_vector.h

#src/OrderedStatic.cpp
#src/SafeFormat.cpp
src/Singleton.cpp
src/SmallObj.cpp
#src/SmartPtr.cpp
#src/StrongPtr.cpp
)

ADD_LIBRARY(${TORA_LOKI_LIB} STATIC ${TORA_LOKI_LIB_SOURCES} )

=== extlibs/parsing.cpp/Makefile ===
.PRECIOUS=.o

#ANTLRGRAMMARS ?= $(wildcard *.g)
ANTLRGRAMMARS = PLSQLGuiLexer.g PLSQLGuiLexerJava.g MySQLGuiLexer.g #PLSQLParser.g
HEADERS = $(wildcard *.hpp) $(wildcard *.inl)
SOURCES = $(wildcard *.cpp)
PSOURCES = $(wildcard PLSQLParser*.cpp) PLSQLLexer.cpp
POBJS = $(PSOURCES:.cpp=.o)
T5SOURCES = $(wildcard OracleDML*.cpp)
T5OBJS    = $(T5SOURCES:.cpp=.o)
GRAMMAROPTIONS= -report -Xconversiontimeout 1500000 -Xwatchconversion
ANTLR = antlr-complete-3.5.3-SNAPSHOT.jar
CXX = clang++

.SUFFIXES:

INCLUDES= -I. -I../libantlr3cpp-3.5.3/include/
#INCLUDES= -I. -I../../../antlr3/runtime/Cpp/include/ -I../../../boost_1_46_1/

CXXFLAGS=-ggdb3 -O0 -fno-inline -std=c++14
#CXXFLAGS=-ggdb3 -Os -std=c++14

UOBJS= utils.o

all: t0 t1 t2 t4 t5 m0 m1 p0 s0 s1 s2 s3 p1

$(ANTLR): org/antlr/codegen/templates/Cpp/Cpp.stg \
	org/antlr/codegen/templates/Cpp/AST.stg \
	org/antlr/codegen/templates/Cpp/ASTParser.stg
	jar uvf $(ANTLR) org/antlr/codegen/templates/*/*.stg

t0:	t0.cpp PLSQLGuiLexer.tokens t0.cpp $(UOBJS) PLSQLGuiLexer.o Makefile UserGuiTraits.hpp
	$(CXX) $(CXXFLAGS) -DUSESTL $(INCLUDES) $(UOBJS) t0.cpp PLSQLGuiLexer.o $(LIBS) -o $@

t1:	t1.cpp PLSQLLexer.tokens PLSQLParser.tokens t1.cpp $(UOBJS) $(POBJS) Makefile UserTraits.hpp
	$(CXX) $(CXXFLAGS) -DUSESTL $(INCLUDES) $(UOBJS) t1.cpp $(POBJS) -o $@

t2:	t2.cpp PLSQLLexer.tokens PLSQLParser.tokens t1.cpp $(UOBJS) $(PSOURCES) $(POBJS) Makefile UserTraits.hpp
	$(CXX) $(CXXFLAGS) -DUSEBOOST $(INCLUDES) $(UOBJS) t2.cpp $(POBJS) $(LIBS) -o $@

t4:	t4.cpp PLSQLLexer.tokens PLSQLParser.tokens $(UOBJS) $(PSOURCES) $(POBJS) Makefile UserTraits.hpp
	$(CXX) $(CXXFLAGS) -DUSESTL $(INCLUDES) $(UOBJS) t4.cpp $(POBJS) -o $@

t5:	t5.cpp OracleDMLLexer.tokens OracleDML.tokens $(UOBJS) $(T5OBJS) Makefile OracleDMLTraits.hpp
	$(CXX) $(CXXFLAGS) -DUSESTL $(INCLUDES) $(UOBJS) $(T5OBJS) t5.cpp -o $@

check:	check.cpp OracleDMLLexer.tokens OracleDML.tokens $(UOBJS) $(T5OBJS) Makefile OracleDMLTraits.hpp
	$(CXX) $(CXXFLAGS) -DUSESTL $(INCLUDES) $(UOBJS) $(T5OBJS) check.cpp -o $@

m0:	m0.cpp MySQLGuiLexer.tokens $(UOBJS) MySQLGuiLexer.o Makefile UserGuiTraits.hpp
	$(CXX) $(CXXFLAGS) -DUSESTL $(INCLUDES) $(UOBJS) m0.cpp MySQLGuiLexer.o $(LIBS) -o $@

m1:	m1.cpp MySQLLexer.tokens $(UOBJS) MySQLLexer.o Makefile UserTraits.hpp
	$(CXX) $(CXXFLAGS) -DUSESTL $(INCLUDES) $(UOBJS) $@.cpp MySQLLexer.o $(LIBS) -o $@

p0:	p0.cpp OraclePLSQL.tokens $(UOBJS) OraclePLSQLLexer.o OraclePLSQLParser.o Makefile UserGuiTraits.hpp
	$(CXX) $(CXXFLAGS) -DUSESTL $(INCLUDES) $(UOBJS) p0.cpp OraclePLSQLLexer.o OraclePLSQLParser.o -o $@

s0:	s0.cpp SQLMini.tokens $(UOBJS) Makefile UserMiniTraits.hpp
	$(CXX) $(CXXFLAGS) -DUSESTL $(INCLUDES) $(UOBJS) s0.cpp SQLMiniLexer.cpp SQLMiniParser.cpp $(LIBS) -o $@

s1:	s1.cpp S1.tokens $(UOBJS) Makefile UserMiniTraits.hpp
	$(CXX) $(CXXFLAGS) -DUSESTL $(INCLUDES) $(UOBJS) s1.cpp S1Lexer.cpp S1Parser.cpp $(LIBS) -o $@

s2:	s2.cpp S2.tokens $(UOBJS) Makefile UserMiniTraits.hpp
	$(CXX) $(CXXFLAGS) -DUSESTL $(INCLUDES) $(UOBJS) s2.cpp S2Lexer.cpp S2Parser.cpp $(LIBS) -o $@

s3:	s3.cpp S3.tokens $(UOBJS) Makefile UserMiniTraits.hpp
	$(CXX) $(CXXFLAGS) -DUSESTL $(INCLUDES) $(UOBJS) s3.cpp S3Lexer.cpp S3Parser.cpp $(LIBS) -o $@

p1:	p1.cpp PostgreSQLGuiLexer.tokens $(UOBJS) PostgreSQLGuiLexer.g.o Makefile UserGuiTraits.hpp
	$(CXX) $(CXXFLAGS) -DUSESTL $(INCLUDES) $(UOBJS) p1.cpp PostgreSQLGuiLexer.o $(LIBS) -o $@

clean:
	rm -f *.o *Lexer*.[ch]pp *Parser.[ch]pp OracleDML_*.[ch]pp OracleDML.[ch]pp t0 t1 t2 t4 t5 m0 m1 s0 s1 s2 s3 p0 p1 check *.tokens

install:
	cp PLSQLGuiLexer.cpp ../../src/parsing/PLSQLGuiLexer.cc
	cp PLSQLGuiLexer.hpp ../../src/parsing/PLSQLGuiLexer.hpp
	#cp UserGuiTraits.hpp ../../src/parsing/UserGuiTraits.hpp
	#cp TokenAttr.hpp     ../../src/parsing/TokenAttr.hpp
	#cp PLSQLLexer.cpp    ../../src/parsing/PLSQLLexer.cc
	#cp PLSQLParser.cpp   ../../src/parsing/PLSQLParser.cc
	#cp PLSQLParser_PLSQLCommons.cpp    ../../src/parsing/PLSQLParser_PLSQLCommons.cc
	#cp PLSQLParser_PLSQL_DMLParser.cpp ../../src/parsing/PLSQLParser_PLSQL_DMLParser.cc
	#cp PLSQLParser_PLSQLKeys.cpp       ../../src/parsing/PLSQLParser_PLSQLKeys.cc
	#cp PLSQLParser_SQLPLUSParser.cpp   ../../src/parsing/PLSQLParser_SQLPLUSParser.cc
	#cp PLSQLParser.hpp                 ../../src/parsing/PLSQLParser.hpp
	#cp PLSQLParser_PLSQLCommons.hpp    ../../src/parsing/PLSQLParser_PLSQLCommons.hpp
	#cp PLSQLParser_PLSQL_DMLParser.hpp ../../src/parsing/PLSQLParser_PLSQL_DMLParser.hpp
	#cp PLSQLParser_PLSQLKeys.hpp       ../../src/parsing/PLSQLParser_PLSQLKeys.hpp
	#cp PLSQLParser_SQLPLUSParser.hpp   ../../src/parsing/PLSQLParser_SQLPLUSParser.hpp
	#cp MySQLLexer.cpp                  ../../src/parsing/MySQLLexer.cc
	#cp MySQLLexer.hpp                  ../../src/parsing/MySQLLexer.hpp
	#cp OracleDML.cpp 		   ../../src/parsing/OracleDML.cc
	#cp OracleDML.hpp		   ../../src/parsing/OracleDML.hpp
	#cp OracleDML_OracleDMLCommons.cpp  ../../src/parsing/OracleDML_OracleDMLCommons.cc
	#cp OracleDML_OracleDMLCommons.hpp  ../../src/parsing/OracleDML_OracleDMLCommons.hpp
	#cp OracleDML_OracleDMLKeys.cpp	   ../../src/parsing/OracleDML_OracleDMLKeys.cc
	#cp OracleDML_OracleDMLKeys.hpp	   ../../src/parsing/OracleDML_OracleDMLKeys.hpp
	#cp OracleDMLLexer.cpp		   ../../src/parsing/OracleDMLLexer.cc
	#cp OracleDMLLexer.hpp		   ../../src/parsing/OracleDMLLexer.hpp
	#cp OracleDMLTraits.hpp		   ../../src/parsing/OracleDMLTraits.hpp
	cp MySQLGuiLexer.cpp               ../../src/parsing/MySQLGuiLexer.cc
	cp MySQLGuiLexer.hpp               ../../src/parsing/MySQLGuiLexer.hpp
	cp PostgreSQLGuiLexer.cpp          ../../src/parsing/PostgreSQLGuiLexer.cc
	cp PostgreSQLGuiLexer.hpp          ../../src/parsing/PostgreSQLGuiLexer.hpp

%.u: %.g
	@echo "Bulding dependencies for "$<
	java -jar $(ANTLR) -depend $< > $@
	@grep ":" $@ |awk 'BEGIN {printf "ANTLRGENLIST := " }{printf " " $$1}END {print ""}'  >> $@.tmp
	@cat $@.tmp >> $@
	$(RM) $@.tmp

%.tokens %Lexer.cpp %Parser.cpp %Lexer.hpp %Parser.hpp: %.g $(ANTLR)
	java -Xmx10240m -jar $(ANTLR) $(GRAMMAROPTIONS) $<

# PLSQL_DMLParser.o: PLSQL_DMLParser.cpp PLSQL_DMLParser.tokens
# 	$(CXX) $(CXXFLAGS) $(INCLUDES) -c PLSQL_DMLParser.c -o $@


ifneq ($(MAKECMDGOALS),clean)
ifneq ($(strip $(ANTLRGRAMMARS)),)
#-include $(ANTLRGRAMMARS:.g=.u)
endif
endif

%.o: %.cpp $(HEADERS) utils.hpp
	$(CXX) $(CXXFLAGS) -DUSESTL $(INCLUDES) -c $< -o $@

=== extlibs/parsing/CMakeLists.txt ===
set(PARSING_SRCS
	error_handler.c
	error_handler.h
	macros.h
	OraclePLSQLLexer.c
	OraclePLSQLLexer.h
	OraclePLSQLParser.c
	OraclePLSQLParser.h
	OracleSQLLexer.c
	OracleSQLLexer.h
	OracleSQLParser.c
	OracleSQLParser.h
	tplsqlparseoracle.cpp
	tsqllexeroracle.cpp
	tsqlparseoracle.cpp
	tsqllexeroracle2.cpp
	PLSQLGuiLexer.cpp
)

INCLUDE_DIRECTORIES(
  ${CMAKE_SOURCE_DIR}/extlibs/libantlr3c-3.3/include
  ${CMAKE_BINARY_DIR}/extlibs/libantlr3c-3.3          # generated antlr3config.h
  ${CMAKE_SOURCE_DIR}/extlibs/libantlr3cpp-3.5.1/include
  ${CMAKE_SOURCE_DIR}/src                             # core/tologger.h
)

IF(Boost_FOUND)
  INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIRS})
ENDIF()

ADD_DEFINITIONS("-DTSQLPARSER_MAKE_DLL")

# Windows DLL cannot refer to symbols defined in the main application or in previously loaded DLLs. 
# and the parsing.lib reffers to tora logging mechanism
# therefore both libs antlr3c and parsing are static on Windows, while beeing shared on Linux
# Note: if they were static on Linux they would need --whole-archive link option.
#if(WIN32)
#  ADD_LIBRARY(parsing STATIC ${PARSING_SRCS})
#else(WIN32)
  ADD_LIBRARY(parsing SHARED ${PARSING_SRCS})
  SET_TARGET_PROPERTIES(parsing PROPERTIES ENABLE_EXPORTS ON)
  TARGET_LINK_LIBRARIES(parsing ${QT_LIBRARIES} antlr3c ${TORA_LIB})
  SET(LIBRARY_OUTPUT_PATH   "${CMAKE_BINARY_DIR}/src/")
#endif(WIN32)

=== extlibs/qscintilla2/CMakeLists.txt ===
# Warning: all lexers compilation and building is mandatory for successful linking!
# Warning: it is possible that FILE GLOB is evaluated only once - enforce cmake re-run if qsciscintilla version changes

ADD_DEFINITIONS("-DQT")
ADD_DEFINITIONS("-DSCI_LEXER")
ADD_DEFINITIONS("-DQSCINTILLA_MAKE_DLL")
ADD_DEFINITIONS("-DSCINTILLA_QT")

SET(qsciscintilla_VERSION_MAJOR 2)
SET(qsciscintilla_VERSION_MINOR 9)
SET(qsciscintilla_VERSION_PATCH 0)
SET(qsciscintilla_VERSION ${qsciscintilla_VERSION_MAJOR}.${qsciscintilla_VERSION_MINOR}.${qsciscintilla_VERSION_PATCH})

FILE(GLOB TORA_QSCINTILLA2_MOC_CLASSES "include/*.h" "lexlib/*.h" "Qt4Qt5/*.h" "Qt4Qt5/Qsci/*.h" "src/*.h")

FILE(GLOB TORA_QSCINTILLA2_LIB_SOURCES "lexers/*.cpp" "lexlib/*.cpp" "Qt4Qt5/*.cpp" "src/*.cpp")

if(QT5_BUILD)
QT5_WRAP_CPP(TORA_QSCINTILLA2_MOC_SOURCES ${TORA_QSCINTILLA2_MOC_CLASSES})
else()
QT4_WRAP_CPP(TORA_QSCINTILLA2_MOC_SOURCES ${TORA_QSCINTILLA2_MOC_CLASSES})
endif()

SET(TORA_QSCINTILLA2_LIB "tora_qscintilla2_lib")
ADD_LIBRARY(${TORA_QSCINTILLA2_LIB} STATIC ${TORA_QSCINTILLA2_LIB_SOURCES} ${TORA_QSCINTILLA2_MOC_SOURCES})

SET_TARGET_PROPERTIES(${TORA_QSCINTILLA2_LIB} PROPERTIES VERSION ${qsciscintilla_VERSION} SOVERSION ${qsciscintilla_VERSION_MAJOR})

=== extlibs/stack/CMakeLists.txt ===
INCLUDE_DIRECTORIES(
${CMAKE_SOURCE_DIR}/src/stack/
)

SET(STACK_LIB_SOURCES
stack.hpp
stack.cpp
)

SET(STACK_LIB "stack_lib")

ADD_LIBRARY(${STACK_LIB} STATIC ${STACK_LIB_SOURCES})

IF("${CMAKE_SYSTEM_PROCESSOR}" STREQUAL "x86_64" AND CMAKE_COMPILER_IS_GNUCC)
  SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -fPIC"  )
  SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -fPIC"  )
  SET_TARGET_PROPERTIES( stack_lib PROPERTIES COMPILE_FLAGS -fPIC)
ENDIF()

=== extlibs/trotl/CMakeLists.txt ===
##############################################################################################################
########## CMake Setup                                                                              ##########
#
# Mostly copied from Tora
# 
#Set our CMake minimum version
CMAKE_MINIMUM_REQUIRED(VERSION 2.6.0 FATAL_ERROR)

# handle new cmake versions correctly
if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
  cmake_policy(SET CMP0005 NEW)
endif(COMMAND cmake_policy)

#CMAKE_POLICY(SET CMP0042 OLD) # MACOSX_RPATH

#Pretty colors
SET(CMAKE_COLOR_MAKEFILE ON)
#Dont force verbose
SET(CMAKE_VERBOSE_MAKEFILE ON)
##SET(CMAKE_VERBOSE_MAKEFILE OFF)
#Include current dir
SET(CMAKE_INCLUDE_CURRENT_DIR TRUE)


#Set the custom CMake module directory where our include/lib finders are
SET(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules")

#Project Setup
PROJECT(trotl)
#Set our version values
#Final version is ${VERSION} = ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}${VERSION_SUFFIX}
#where VERSION_SUFFIX is of the form "", "cvs" or "Ncvs" (N being the minor patch level)
SET (VERSION_MAJOR "0")
SET (VERSION_MINOR "1")
SET (VERSION_PATCH "0")
SET (VERSION_SUFFIX "")
SET (VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}${VERSION_SUFFIX})

SET (LIB_NAME "trotl")

# IF (CMAKE_COMPILER_IS_GNUCC)  
#     SET(CXX_WARNINGS "-Wall")
#     SET(CMAKE_CXX_FLAGS_RELEASE "-O2 ${CXX_WARNINGS} -rdynamic -fvisibility-inlines-hidden")
#     SET(CMAKE_C_FLAGS_RELEASE "-O2 ${CXX_WARNINGS} -rdynamic -fvisibility-inlines-hidden")
#     SET(CMAKE_CXX_FLAGS_DEBUG "-O0 -ggdb3 -fno-inline ${CXX_WARNINGS} -fstrict-aliasing -rdynamic")
#     SET(CMAKE_C_FLAGS_DEBUG "-O0 -ggbb3 -fno-inline ${CXX_WARNINGS} -fstrict-aliasing -rdynamic")
# ENDIF (CMAKE_COMPILER_IS_GNUCC)  

# Lets disable Wall warnings due the MSVC too much talkative
# output.
# MSVC, MSVC_IDE, MSVC60, MSVC70, MSVC71, MSVC80, CMAKE_COMPILER_2005
IF (MSVC)
    ADD_DEFINITIONS(-D_CRT_SECURE_NO_WARNINGS )
    SET (CXX_WARNINGS "/wd4251")
    SET (CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} ${CXX_WARNINGS}")

#	SET (CMAKE_SHARED_LINKER_FLAGS "/INCREMENTAL:NO")
#	SET (CMAKE_SHARED_LINKER_FLAGS_DEBUG "/INCREMENTAL:NO")
#	SET (CMAKE_EXE_LINKER_FLAGS "/INCREMENTAL:NO")
#	SET (CMAKE_EXE_LINKER_FLAGS_DEBUG "/MANIFEST /MANIFESTUAC:\"level='asInvoker' uiAccess='false'\" ")
#	SET (CMAKE_EXE_LINKER_FLAGS_DEBUG "${CMAKE_EXE_LINKER_FLAGS_DEBUG} /DEBUG /SUBSYSTEM:CONSOLE ")
#	SET (CMAKE_EXE_LINKER_FLAGS_DEBUG "${CMAKE_EXE_LINKER_FLAGS_DEBUG} /DYNAMICBASE /NXCOMPAT /MACHINE:X86 ")
#	SET (CMAKE_EXE_LINKER_FLAGS_DEBUG "${CMAKE_EXE_LINKER_FLAGS_DEBUG} /ERRORREPORT:PROMPT ")
#	SET (CMAKE_SHARED_LINKER_FLAGS_DEBUG "/DLL /MANIFEST /MANIFESTFILE:trotl.dll.manifest ")
#	SET (CMAKE_SHARED_LINKER_FLAGS_DEBUG "${CMAKE_SHARED_LINKER_FLAGS_DEBUG} /MANIFESTUAC:\"level='asInvoker' uiAccess='false'\" ")
#	SET (CMAKE_SHARED_LINKER_FLAGS_DEBUG "${CMAKE_SHARED_LINKER_FLAGS_DEBUG} /DEBUG /PDB:trotl.pdb /DYNAMICBASE:NO ")
#	SET (CMAKE_SHARED_LINKER_FLAGS_DEBUG "${CMAKE_SHARED_LINKER_FLAGS_DEBUG} /ERRORREPORT:PROMPT ")
#	SET (CMAKE_MODULE_LINKER_FLAGS "/INCREMENTAL:NO")
#	SET (CMAKE_MODULE_LINKER_FLAGS_DEBUG "/INCREMENTAL:NO")
ENDIF (MSVC)


IF(ORACLE_FOUND)
    MESSAGE("-- Oracle OCI Library Found OK")
ELSE(ORACLE_FOUND)
    MESSAGE(FATAL_ERROR "No Oracle client found")
ENDIF(ORACLE_FOUND)

IF(ORACLE_HAS_XML)
    MESSAGE("-- Oracle XDK Library Found OK")
ELSE(ORACLE_HAS_XML)
    MESSAGE(STATUS "-- No Oracle XDK found: ignoring")
ENDIF(ORACLE_HAS_XML)

ADD_SUBDIRECTORY(src)

=== obsolete/libantlr3c-3.5.1/CMakeLists.txt ===

##project(libantlr3c)
OPTION(ANTLR3_NODEBUGGER "ANTLR debugger not required" ON)

SET (VERSION "3.5")
SET (PACKAGE_BUGREPORT "jimi@temporal-wave.com")
#SET (PACKAGE ${CMAKE_PROJECT_NAME})

SET (PACKAGE_VERSION ${VERSION})
SET (PACKAGE_NAME ${CMAKE_PROJECT_NAME})
SET (PACKAGE_TARNAME ${CMAKE_PROJECT_NAME})
SET (PACKAGE_STRING "${CMAKE_PROJECT_NAME} ${VERSION}")

cmake_minimum_required(VERSION 2.6)

INCLUDE (CheckIncludeFiles)
INCLUDE (CheckFunctionExists)

CHECK_INCLUDE_FILES ( "arpa_nameser.h" HAVE_ARPA_NAMESER_H )
CHECK_INCLUDE_FILES ( "ctype.h" HAVE_CTYPE_H )
CHECK_INCLUDE_FILES ( "dlfcn.h" HAVE_DLFCN_H )
CHECK_INCLUDE_FILES ( "inttypes.h" HAVE_INTTYPES_H )
CHECK_INCLUDE_FILES ( "malloc.h" HAVE_MALLOC_H )
CHECK_INCLUDE_FILES ( "sys/malloc.h" HAVE_SYS_MALLOC_H )
CHECK_INCLUDE_FILES ( "memory.h" HAVE_MEMORY_H )
CHECK_INCLUDE_FILES ( "netdb.h" HAVE_NETDB_H )
CHECK_INCLUDE_FILES ( "netinet/in.h" HAVE_NETINET_IN_H )
CHECK_INCLUDE_FILES ( "netinet/tcp.h" HAVE_NETINET_TCP_H )
CHECK_INCLUDE_FILES ( "resolv.h" HAVE_RESOLV_H )
CHECK_INCLUDE_FILES ( "sys/resolv.h" HAVE_RESOLV_H )
CHECK_INCLUDE_FILES ( "socket.h" HAVE_SOCKET_H )
CHECK_INCLUDE_FILES ( "sys/socket.h" HAVE_SYS_SOCKET_H )
CHECK_INCLUDE_FILES ( "stdarg.h" HAVE_STDARG_H )
CHECK_INCLUDE_FILES ( "stdint.h" HAVE_STDINT_H )
CHECK_INCLUDE_FILES ( "stdlib.h" HAVE_STDLIB_H )
CHECK_INCLUDE_FILES ( "string.h" HAVE_STRING_H )
CHECK_INCLUDE_FILES ( "strings.h" HAVE_STRINGS_H )
CHECK_INCLUDE_FILES ( "sys/stat.h" HAVE_SYS_STAT_H )
CHECK_INCLUDE_FILES ( "sys/types.h" HAVE_SYS_TYPES_H )
CHECK_INCLUDE_FILES ( "unistd.h" HAVE_UNISTD_H )

CHECK_FUNCTION_EXISTS ( "accept" HAVE_ACCEPT )
CHECK_FUNCTION_EXISTS ( "memmove" HAVE_MEMMOVE )
CHECK_FUNCTION_EXISTS ( "memset" HAVE_MEMSET ) 
CHECK_FUNCTION_EXISTS ( "strdup" HAVE_STRDUP )

IF(CMAKE_SIZEOF_VOID_P EQUAL "8")
  SET(ANTLR3_USE_64BIT 1)
ENDIF(CMAKE_SIZEOF_VOID_P EQUAL "8")
  
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/antlr3config.h.in.cmake ${CMAKE_CURRENT_BINARY_DIR}/antlr3config.h)

set(ANTLR3_SRCS
  src/antlr3baserecognizer.c
  src/antlr3basetreeadaptor.c
  src/antlr3basetree.c
  src/antlr3bitset.c
  src/antlr3collections.c
  src/antlr3commontoken.c
  src/antlr3commontreeadaptor.c
  src/antlr3commontree.c
  src/antlr3commontreenodestream.c
  src/antlr3convertutf.c
  src/antlr3cyclicdfa.c
  src/antlr3debughandlers.c
  src/antlr3encodings.c
  src/antlr3exception.c
  src/antlr3filestream.c
  src/antlr3inputstream.c
  src/antlr3intstream.c
  src/antlr3lexer.c
  src/antlr3parser.c
  src/antlr3rewritestreams.c
  src/antlr3string.c
  src/antlr3tokenstream.c
  src/antlr3treeparser.c
)

set(ANTLR3_HDRS
  include/antlr3baserecognizer.h
  include/antlr3basetreeadaptor.h
  include/antlr3basetree.h
  include/antlr3bitset.h
  include/antlr3collections.h
  include/antlr3commontoken.h
  include/antlr3commontreeadaptor.h
  include/antlr3commontree.h
  include/antlr3commontreenodestream.h
  include/antlr3convertutf.h
  include/antlr3cyclicdfa.h
  include/antlr3debugeventlistener.h
  include/antlr3defs.h
  include/antlr3encodings.h
  include/antlr3errors.h
  include/antlr3exception.h
  include/antlr3filestream.h
  include/antlr3.h
  include/antlr3input.h
  include/antlr3interfaces.h
  include/antlr3intstream.h
  include/antlr3lexer.h
  include/antlr3memory.h
  include/antlr3parser.h
  include/antlr3parsetree.h
  include/antlr3recognizersharedstate.h
  include/antlr3rewritestreams.h
  include/antlr3string.h
  include/antlr3tokenstream.h
  include/antlr3treeparser.h

  antlr3config.h
  )

include_directories(include ${CMAKE_CURRENT_BINARY_DIR})

##if(WIN32)
##  add_library(antlr3c STATIC ${ANTLR3_SRCS})
##else(WIN32)
#  add_library(antlr3c SHARED ${ANTLR3_SRCS})
#  set(LIBRARY_OUTPUT_PATH   "${CMAKE_BINARY_DIR}/src/")
##endif(WIN32)

add_library(antlr3c STATIC ${ANTLR3_SRCS})

=== obsolete/windows/CMakeLists.txt ===
INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/src/windows/)

SET(WINDOWS_LIB_SOURCES
	dummy.cpp
	resource.h
	tora.ico
	tora.rc
)

SET(WINDOWS_LIB "windows_lib")
ADD_LIBRARY(${WINDOWS_LIB} STATIC ${WINDOWS_LIB_SOURCES})


# Error detected with generator Visual Studio 10 Win64
# > LINK : warning LNK4068: /MACHINE not specified; defaulting to X86
# > fatal error LNK1112: module machine type 'x64' conflicts with target machine type 'X86'
#
# There is no default value for static libraries and cmake isn't setting it either.
# We fix this by adding the flag manually.
if(MSVC)
	if( CMAKE_SIZEOF_VOID_P EQUAL 8 )
		set_target_properties(${WINDOWS_LIB} PROPERTIES STATIC_LIBRARY_FLAGS "/machine:X64")
	else()
		set_target_properties(${WINDOWS_LIB} PROPERTIES STATIC_LIBRARY_FLAGS "/machine:X86")
	endif()
endif()

=== debian/changelog ===
tora (3.0.85-0ubuntu1) UNRELEASED; urgency=medium

  * Fix SEGFAULTs
  * New Session broswer - kill session
  * New BFILE datatype support. Fixes #39

 -- Ivan Brezina <ivan@haf>  Sat, 09 Jul 2016 19:27:36 +0200

tora (3.0.41-0ubuntu1) UNRELEASED; urgency=medium

  * MySQL related fixes

 -- Ivan Brezina <ivan@haf>  Thu, 21 Apr 2016 23:01:32 +0200

tora (3.0.21-0ubuntu1) UNRELEASED; urgency=medium

  * Fix for bug #24 Bindings variables
  * Fix for bug #25 Database link does not work
  * Partial fix for bug #26 no feedback on updated or deleted rows

 -- Ivan Brezina <ivan@haf>  Sun, 10 Apr 2016 20:57:39 +0200

tora (3.0.0-1ubuntu1) RELEASED; urgency=medium

  * New Upstream version 3.0.0

 -- Ivan Brezina <ivan@thinkpad>  Sun, 03 Apr 2016 22:28:28 +0100

tora (2.1.3-1) unstable; urgency=low

  * New Upstream version 2.1.3
  * Bumped Standards-Version to 3.9.1, no changes needed.

 -- Michael Meskes <meskes@debian.org>  Mon, 27 Sep 2010 10:06:11 +0200

tora (2.1.2-1) unstable; urgency=low

  * Added debug package. (Closes: #560064)
  * New Upstream version 2.1.2
    * Improved: Add editor option for uppler/lowercase object names
    * Improved: Db extract/compare tool now remembers widgets states
    * New: Filesystem completer for target line edit
    * Improved: Compatibility with sql+
    * New: Color/pixmap identifier for connection
    * Improved: Schema browser improvements
    * New: Ability to add external static check
    * New: Save package specification and body to one file
    * New: Initial support for creating/modifying tables
    * Bugfixes
  * Bumped Standards-Version to 3.8.4, no changes needed.
  * No patches needed anymore, removed patch system.

 -- Michael Meskes <meskes@debian.org>  Tue, 30 Mar 2010 13:14:16 +0200

tora (2.1.1-1) unstable; urgency=low

  * New upstream version.

 -- Michael Meskes <meskes@debian.org>  Thu, 19 Nov 2009 15:18:19 +0100

tora (2.1.0-1) unstable; urgency=low

  * New upstream version, the rebuild closes: #540046.
  * Bumped Standards-Version to 3.8.3, no changes needed.
  * New project homepage.
  * Removed no longer needed 01_missing_includes.dpatch.
  * Removed no longer used dh_desktop call.
  * Added README.source file.

 -- Michael Meskes <meskes@debian.org>  Fri, 11 Sep 2009 12:37:52 +0200

tora (2.0.0-4) unstable; urgency=low

  * Added patch to add missing include directives, closes: #526166

 -- Michael Meskes <meskes@debian.org>  Mon, 04 May 2009 16:12:37 +0200

tora (2.0.0-3) unstable; urgency=low

  * Cleaned up packaging a little bit.
  * Added homepage information to control file.
  * Bumped Standards-Version to 3.8.1.
  * Released to unstable.

 -- Michael Meskes <meskes@debian.org>  Tue, 07 Apr 2009 13:16:05 +0200

tora (2.0.0-2) experimental; urgency=low

  * Added build dependency on libpq-dev to get full PostgreSQL support.

 -- Michael Meskes <meskes@debian.org>  Tue, 06 Jan 2009 08:49:43 +0100

tora (2.0.0-1) experimental; urgency=low

  * New upstream version for KDE4/Qt4.
  * Added watch file.
  * Updated to standards version 3.8.0, no additional changes needed.
  * No longer need texinfo to build, the html files are part of the tarball.
  * Streamlined build dependencies.
  * Updated copyright file.

 -- Michael Meskes <meskes@debian.org>  Sat, 03 Jan 2009 20:51:13 +0100

tora (1.3.23-1) unstable; urgency=low

  * New upstream version
  * Moved config.* handling from clean target to configure target.

 -- Michael Meskes <meskes@debian.org>  Wed, 26 Mar 2008 09:55:07 +0100

tora (1.3.22-7) unstable; urgency=low

  * Removed build dependency on libqt3-compat-headers, closes: #464914
  * Added include directives needed by gcc-4.3, closes: #462239

 -- Michael Meskes <meskes@debian.org>  Mon, 11 Feb 2008 10:57:12 +0100

tora (1.3.22-6) unstable; urgency=low

  * Fixed clean target yet again so building twice in a row is possible.
  * Bumped up build dependency on debhelper to correct version.

 -- Michael Meskes <meskes@debian.org>  Thu, 10 Jan 2008 11:55:07 +0100

tora (1.3.22-5) unstable; urgency=low

  * Bumped standards version to 3.7.3.
  * Bumped tora.dekstop to version 1.0, closes: #455588
  * Added call to dh_desktop.
  * Bumbed debhelper version to 5.
  * Build-depend on autotools-dev and cp up-to-date files to archive.
  * Do not ignore errors in "make clean".

 -- Michael Meskes <meskes@debian.org>  Tue, 11 Dec 2007 10:32:06 +0100

tora (1.3.22-4) unstable; urgency=low

  * Removed build dependency on g++, closes: #452976
  * Also removed build dependency on libqt3-mt-dev because kdelibs4-dev
    depends on it.
  * Made menu file adhere new standard.
  * Do not install sources for help files.

 -- Michael Meskes <meskes@debian.org>  Thu, 06 Dec 2007 10:13:24 +0100

tora (1.3.22-3) unstable; urgency=low

  * Moved to team maintenance:
    Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>.

 -- Michael Meskes <meskes@debian.org>  Thu, 22 Nov 2007 11:12:43 +0100

tora (1.3.22-2) unstable; urgency=low

  * Fixed help system
  * Moved translations to /usr/share, closes: #448950
  * Remove deprecated debian.patch file.

 -- Michael Meskes <meskes@debian.org>  Tue, 20 Nov 2007 13:05:47 +0100

tora (1.3.22-1) unstable; urgency=low

  * New upstream version.
  * Added texinfo to Build-Depends, closes: #443296
  * Build process now uses dpatch.

 -- Michael Meskes <meskes@debian.org>  Fri, 21 Sep 2007 13:48:45 +0200

tora (1.3.21pre22-3) unstable; urgency=low

  * Do not remove files from the orig tarball in our clean target, closes: #442749
  * Resynced with svn to prepare for upcoming 1.3.22 release.

 -- Michael Meskes <meskes@debian.org>  Tue, 18 Sep 2007 11:15:46 +0200

tora (1.3.21pre22-2) unstable; urgency=low

  * Fixed incorrect display of UTF-8 characters, closes: #418524
  
 -- Michael Meskes <meskes@debian.org>  Fri, 08 Jun 2007 14:44:29 +0200

tora (1.3.21pre22-1) unstable; urgency=low

  * Applied latest upstream pre1.3.22 patch.
  * Moved to qscintilla 1.7.
  


=== debian/control ===
Source: tora
Section: misc
Priority: optional
Maintainer: Ivan Brezina <ivan@thinkpad>
#Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
#Uploaders: Michael Meskes <meskes@debian.org>
Build-Depends: debhelper (>= 5), cdbs, cmake, qt5-qmake, qtbase5-dev, qttools5-dev, qttools5-dev-tools, libqt5scintilla2-dev
Standards-Version: 3.9.1
Homepage: http://www.torasql.com
Vcs-Git: git://git.debian.org/pkg-kde/kde-extras/tora.git
Vcs-Browser: http://git.debian.org/?p=pkg-kde/kde-extras/tora.git

Package: tora
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: A graphical toolkit for database developers and administrators
 Tora features a schema browser, SQL worksheet, PL/SQL editor & debugger,
 storage manager, rollback segment monitor, instance manager, and SQL output
 viewer. Via qt5 it can access PostgreSQL and MySQL directly. Any other
 database systems can be accessed via ODBC.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

#include /usr/share/cdbs/1/rules/debhelper.mk
#include /usr/share/cdbs/1/class/cmake.mk
#DEB_DBG_PACKAGES := tora-dbg

install/tora::
	# remove some file we don't want to install
	rm -f $(CURDIR)/debian/tmp/usr/share/doc/tora/README.OSX
	rm -f $(CURDIR)/debian/tmp/usr/share/doc/tora/README.LICENSE
	rm -f $(CURDIR)/debian/tmp/usr/share/doc/tora/README.WINDOWS
	rm -f $(CURDIR)/debian/tmp/usr/share/doc/tora/INSTALL
	rm -f $(CURDIR)/debian/tmp/usr/share/doc/tora/COPYING
	rm -f $(CURDIR)/debian/tmp/usr/share/doc/tora/ChangeLog
	rm -f $(CURDIR)/debian/tmp/usr/share/doc/tora/changelog
	# this file cannot be installed by dh_install because it has to be renamed
	-install --owner root --group root --mode=644 $(CURDIR)/src/icons/toramini.xpm $(CURDIR)/debian/tora/usr/share/icons/hicolor/16x16/apps/tora.xpm
	# we have a desktop file
	-install --owner root --group root --mode=644 $(CURDIR)/debian/tora.desktop $(CURDIR)/debian/tora/usr/share/applications

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_BUILD_TYPE=Debug -DUSE_PCH=true

override_dh_install:
	@echo "skip dh_install"

override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info --exclude=debian/tora/usr/lib64/libtrotl.so --exclude debian/tora/usr/lib64/tora-3.0/libporacle.so
